#!/pro/plt/plt/Linux_unknown/latest/plt/bin/mred -r

;; Uses the non weighted SP approach to paths.

(require "../rob/base.ss"
         (lib "list.ss")
         (lib "etc.ss")
         (lib "posn.ss" "lang")
         (file "../twooldri/dijkstra.ss")
         "../rob/play-tools.scm"
         "../gmarceau/minimax.ss"
         "../gmarceau/physics.ss"
         )


;; change this for development:
(load "../rob/brain-interfaces2.scm")

;;(current-command-line-arguments (vector "localhost" "3000"))
;(current-command-line-arguments (vector "icfp1.cse.ogi.edu" "22106"))


;; info X tox X toy -> action
;; uses simple dijkstra's
;; incorporating minimax
(define (path-planner info tox toy)
  (debug "goal is " tox "," toy)
  (cond     
    
    [(and
      (info 'packages?)
      (info 'can-take-more-here?))
     (pick-up-packages info)]
    
    [(and (= (info 'x) tox)
          (= (info 'y) toy))
     (drop-packages info)]
    
    ;; else we give our current position to get to the goal.
    [else (let* ((f (dir-func-dist-f (info 'extra)))
                 (f2 (dir-func-point-f (info 'extra)))
                 (cm (lambda (x y) (global-distance-f (make-posn x y))))
		 (cluster (my-cluster (info 'board) (info 'players) (info 'my-id)))
                 (mm-result (if (= (length cluster) 1) false
				(minimax-move (info 'board) cm (info 'my-id) cluster 
                                              500 (make-hash-table 'equal))))
                 )
            (debug "right here baby:" global-direction-f)
            (let ((point-move (global-direction-f (make-posn
                                                   (info 'x) (info 'y))
                                                  (make-posn tox toy))))
              (debug "here!!")
              (debug "MOVE is " point-move)
              
              (let ((res (if (not mm-result) (tom->normal point-move)
                             mm-result)))
                (if (eq? res 'none)
                    (make-drop empty)
                    (make-move res)))
              
            ))]))

            
(define (tom->normal d)
  (cond
    ((eq? d 'east) 'E)
    ((eq? d 'north) 'N)
    ((eq? d 'south) 'S)
    ((eq? d 'west) 'W)
    (else 'none)))


(define (goals info stops)
  (debug "in goals")
  (stops-places stops))

;  ;((stops-update! stops) stops info)
;  (debug "OUR GOAL: " (stops-places stops))
;  (if (info 'deliveries?)
;      ;; we take this path if we are delivering things.
;      ;; (ie, not going to bases) 
;      (begin
;        (debug "there are deliveries")
;        (let ((next-pkg (first mine-packages))
;              (last-goal (dir-func-cur-goal (info 'extra))))
;          (if (posn=? last-goal (info 'dest-posn next-pkg))
;              (info 'dest-posn next-pkg)
;              (begin ;; else our goal from last time changed.
;                (let-values (((a b) ((dir-func-main-f (info 'extra)) (info 'dest-posn next-pkg))))
;                  (set-dir-func-dist-f! (info 'extra) a)
;                  (set-dir-func-point-f! (info 'extra) b))
;                (set-dir-func-cur-goal! (info 'extra) (info 'dest-posn next-pkg))
;                (info 'dest-posn next-pkg))))
;        )
;      (stops-places stops)))
;      
;      ;(let ((next-goal ((stops-nearest stops) stops))
;      ;      (last-goal (dir-func-cur-goal (info 'extra))))
;      ;  (debug "in the else case; next-goal is " next-goal)
;      ;  (debug "and... last-goal is " last-goal)
;      ;  (if (posn=? last-goal next-goal)
;      ;      next-goal
;      ;      (begin ;; else our goal from last time changed.
;      ;        (let-values (((a b) ((dir-func-main-f (info 'extra)) next-goal)))
;      ;            (set-dir-func-dist-f! (info 'extra) a)
;      ;            (set-dir-func-point-f! (info 'extra) b))
;      ;        (set-dir-func-cur-goal! (info 'extra) next-goal)
;      ;        next-goal)))))




;; this is the stops updater
(define (update! stops info)
  'no-update-here)
   


;(define (merge-posns a b)
;  ;(debug "a; b is " a ";" b)
;  (cond
;    ((empty? a) b)
;    ((member-posn? (first a) b)
;     (merge-posns (rest a) b))
;    (else (merge-posns (rest a) (cons (first a) b)))))
;
;(define (member-posn? p ls)
;  (cond
;    ((empty? ls) false)
;    ((and (= (posn-x p)
;             (posn-x (first ls)))
;          (= (posn-y p)
;             (posn-y (first ls))))
;     true)
;    (else (member-posn? p (rest ls)))))
;
;(define (put-bases-in! posn-ls)
;  (set! base-visits
;        (map (lambda (posn)
;               (list (posn-x posn) posn-y posn))
;             posn-ls)))
                      



;; stops
  (define sp1-stops
  (make-stops
   empty ;; list of places
   (lambda (board stops)
     'no-init)
   simple-nearest
   update!))

(define-struct dir-func (cur-goal main-f point-f dist-f))

;;extra
(define my-extra 
  (let ((df (make-dir-func (make-posn 1 1) 'dummy-main-f 'dummy-point-f 'dummy-dist-f)))
    (make-extra (lambda (board id capacity)
                  (set-dir-func-main-f! df (get-path-distance-and-direction-functions board))
                  (let-values (((a b) ((dir-func-main-f df) (make-posn 1 1))))
                    (set-dir-func-dist-f! df a)
                    (set-dir-func-point-f! df b)
                    )
                  )
                  df)))

(define sp1 (create-client path-planner simple-bidder goals sp1-stops my-extra))


;;this has to be the last thing in the file.
(run-client (client-init sp1) (client-round sp1))
