(module types mzscheme

  (provide (all-defined))
  
  ;;
  ;; ---------------------------------------- command & action ----------------------------------------
  ;;
  ;; These are the what the client *sends* to the server
  ;;
  (define-struct command (bid action)) ;; bid is a num, action is an action

  ;; an action is one of:
  (define-struct move (dir)) ;; dir is a sym: (U 'N 'S 'E 'W)
  (define-struct pick (ids)) ;; ids is a (listof num)
  (define-struct drop (ids)) ;; ids is a (listof num)
  
  ;;
  ;; ---------------------------------------- update & u-action ----------------------------------------
  ;;
  ;; These are what the client *receives* from the server
  ;;
  (define-struct update (id u-actions)) ;; id is a num, u-actions is a (listof u-action)
  
  ;; a u-action is one of:
  (define-struct u-move (dir)) ;; dir is a sym: (U 'N 'S 'E 'W)
  (define-struct u-pick (id)) ;; id is a num
  (define-struct u-drop (id)) ;; id is a num
  (define-struct u-loc (x y)) ;; x and y are nums
  
  ;;
  ;; ---------------------------------------- player ----------------------------------------
  ;;
  (define-struct player (id x y package-ids)) ;; num num num (listof num)
  
  ;;
  ;; ---------------------------------------- package ----------------------------------------
  ;;
  (define-struct package (id dest-x dest-y weight)) ;; num num num num
  )
