(module biding mzscheme 

  (require "pos-cache.ss" "minimax.ss")
  
  (define-struct t (his base-bid agressiveness cap))
  
  (define (make-bidder max-history money agressiveness cap)
    (make-t (make-history max-size) (/ 1 money) agressiveness cap))
  
  (define (bidder-inc! b) 
    (set-t-base-bid b (min (* (t-base-bid b) (t-agressiveness b)) (t-cap b))))
  
  (define (bidder-dec! b money)
    (let ((low-aggre (+ 1 (/ (- 1 (t-aggressiveness b)) 2))))
      (set-t-base-bid b (max (/ (t-base-bid b) low-aggre) (/ 1 money)))))
  
  (define (pick-bid b time-stamp money my-cluster action min-score max-score)
    (let ((cycle (record-position (t-his b) time-stamp my-cluster)))
      (if cycle (bidder-inc! b)
	  (bidder-dec! b money))
      
      (floor (min (t-cap b)
		  (* (max 1 (* money (t-base-bid b)))
		     (if (drop? action) 2 1)
		     (cond ((= max-score eval-max-val) 2)
			   ((> (- max-score min-score) 50) 1.5)
			   (true 1)))))))
  

)