(module union mzscheme
  
  (require "base-gm.ss")
  (provide make-union union-eq? union-data union union-master union-groups)
  
  (define-struct t (parent data))
  
  (define (make-union data) (make-t false data))
  
  (define (union-master a)
    (if (not (t-parent a)) a
	(union-master (t-parent a))))
  
  (define (union-eq? a b)
    (eq? (union-master a) (union-master b)))
  
  (define (union a b)
    (let ((ma (union-master a))
	  (mb (union-master b)))
      (unless (eq? ma mb)
	(set-t-parent! ma mb))))
  
  (define union-data t-data)

  (define (union-groups items)
    (let ((hash (make-hash)))
      (for-each (lambda (item)
		  (let* ((master (union-master item))
			 (group (hash-get hash master (lambda ()
							      empty))))
		    (hash-put! hash master (cons (union-data item) group))))
		items)

      (hash-map hash (lambda (key val) val))))
  
  (define (test)
    (define a (map make-union '(0 1 2 3 4 5 6 7 8 9)))

    (union (list-ref a 0) (list-ref a 4))
    (union (list-ref a 4) (list-ref a 5))
    (union (list-ref a 5) (list-ref a 6))
    (union (list-ref a 4) (list-ref a 7))
  
    (debug (union-eq? (list-ref a 0) (list-ref a 7)))
    (debug (union-groups a)))

  )