;(module base-packages mzscheme

(require (lib "list.ss")
         (lib "etc.ss")
         "../rob/base.ss"
         "../dbt/types.ss")

 ; (provide id->package
 ;          add-package-hash!
 ;          my-space-used
 ;          drop-package-hash!)
  

;; this is a package to keep track of packages at the bases
;; when you get to a base you log everything there
;;  with this hash table.  Then you 

(define base-packages-hash
  (make-hash-table))

;; base ls position -> ls(package)
(define (packages-at-base ls)
  (hash-table-get base-packages-hash ls
                  (lambda ()
                    (false))))


(define (in-table? id)
  (hash-table-get my-packages-hash id (lambda () false)))

(define (drop-package-hash! id)
  (hash-table-remove! my-packages-hash id))

(define (add-package-hash! id pkg)
  (if (not (in-table? id))
      (hash-table-put! my-packages-hash id pkg)
      'already-in-table))

(define (my-space-used player)
  (let ((m (map (lambda (i)
                  (package-weight (id->package i))) (player-package-ids player))))
    (debug "m is " m)
    (foldl + 0 m)))
           
  
  
;)