(module draw-util mzscheme

(require "../dbt/board.ss"
         (lib "list.ss")
         "../rob/base.ss"
         ;;"../dbt/utils.ss"
         "../dbt/types.ss"
         )
  
  (provide show-board)

(define (show-board board players)
  (let ((h (board-height board))
	(w (board-width board)))
    (for down 1 h
	 (for across 1 w
	      (let ((here (who-here? players (shiftw across) (shifth down board))))
		(if (eq? here 'no-one)
		    (show-convert (board-ref board (shiftw across) (shifth down board)))
		    (show-convert here))))
	 (newline))))
  
  (define (shiftw pos)
    pos)
  
  (define (shifth pos board)
    (+ 1 (- (board-height board) pos)))
    

(define dot-symb (string->symbol "."))
(define hash-symb (string->symbol "#"))

(define (show-convert x)
  (display
   (cond
     ((number? x) x)
     ((eq? x 'plain) dot-symb)
     ((eq? x 'water) '~)
     ((eq? x 'home) '@)
     ((eq? x 'wall) hash-symb)
     (else (halt "I don't know that symbol: " x)))))

;(define b (read-board-from-file "../gmarceau-dev/test.map"))

(define (who-here? players x y)
  (let ((result (filter (lambda (p)
                          (and (= (player-x p) x)
                               (= (player-y p) y)))
                        players)))
    (if (empty? result)
        'no-one
        (player-id (first result)))))
  
  ;(show-board b empty)
  
  )