(module tsp-rob mzscheme

  (require "../twooldri/dijkstra.ss"
           "../rob/base.ss"
           (lib "list.ss"))

  (provide get-next-goal)

  ;; board posn list(posn) -> posn
  (define (get-next-goal board source possible-destinations)
    (let-values (((distance-to direction-to)
                  ((get-path-distance-and-direction-functions board) source)))
      (let loop ((dists
                  (map distance-to possible-destinations))
                 (posns possible-destinations)
                 (best-dist 10000000)
                 (best-goal 'dummy))
        (debug "in looper: best-goal is " best-goal)
        (cond
          ((empty? dists) (values best-goal distance-to direction-to))
          ((< (first dists) best-dist)
           (loop (rest dists)
                 (rest posns)
                 (first dists)
                 (first posns)))
          (else (loop
                 (rest dists)
                 (rest posns)
                 best-dist
                 best-goal))))))
  
  )