;; vim: ft=scheme

(module data mzscheme

  (require (lib "posn.ss" "lang")
           (file "../rob/base.ss"))

  (provide get-weight-from-source
           set-weight-from-source
           get-predecessor-of
           set-predecessor-of
           get-weight-between
           set-weight-between)

  ;; 
  ;; aiee! multidimensional arrays would be nice (srfi 25). otherwise, i should
  ;; switch to vectors.
  ;;

  (define weight-to-node (make-hash-table 'equal))
  (define predecessor-to-node (make-hash-table 'equal))

  (define (get-hash-key-from-one posn)
    (string-append (number->string (posn-x posn)) " " (number->string (posn-y posn))))

  (define (get-weight-from-source posn)
    (hash-table-get weight-to-node (get-hash-key-from-one posn)))

  (define (set-weight-from-source posn weight)
    (hash-table-put! weight-to-node (get-hash-key-from-one posn) weight))

  (define (get-predecessor-of posn)
    (hash-table-get predecessor-to-node (get-hash-key-from-one posn)))

  (define (set-predecessor-of posn1 posn2)
    (hash-table-put! predecessor-to-node (get-hash-key-from-one posn1) posn2))


  (define weights-between (make-hash-table 'equal))

  (define (get-hash-key-from-two posn1 posn2)
    (string-append (number->string (posn-x posn1)) " " (number->string (posn-y posn1)) " "
                   (number->string (posn-x posn2)) " " (number->string (posn-y posn2))))

  (define (get-weight-between posn1 posn2)
    (hash-table-get weights-between (get-hash-key-from-two posn1 posn2)))

  (define (set-weight-between posn1 posn2 weight)
    ;; the weight from 1 to 2 is also the weight from 2 to 1.
    (hash-table-put! weights-between (get-hash-key-from-two posn1 posn2) weight)
    (hash-table-put! weights-between (get-hash-key-from-two posn2 posn1) weight)))
